<!DOCTYPE html>
<html lang="en">
   <head>
      <meta charset="UTF-8">
      <meta name="viewport" content="width=device-width, initial-scale=1.0">
      <title>Document</title>
   </head>
   <body>
      <input type="text" placeholder="Ingrese el código a organizar">
      <button onclick="organizeGifts()">Organize Gifts</button>
   </body>
   <script>
      let $giftsPerBox = 10;
      let $boxesPerPale = 5;
      function isItNumber(valor) {
      return Number.isFinite(Number(valor));
      }
      function organizeBlock($numberAsString, $word) {
      let $blockString = '';
      //alert($numberAsString);
      let $numberToAnalyze = Number($numberAsString);
      //alert($numberToAnalyze);
      let pales = Math.floor($numberToAnalyze / ($giftsPerBox * $boxesPerPale));
      
      let boxes = Math.floor(($numberToAnalyze - (pales * $giftsPerBox * $boxesPerPale)) / $giftsPerBox);
      let aditionalGifts = $numberToAnalyze - (pales * $giftsPerBox * $boxesPerPale) - (boxes * $giftsPerBox);
      $blockString  = (pales>0? ('[' + $word+ ']').repeat(pales):'' ) +
                      (boxes>0?('{' + $word  + '}').repeat(boxes):'') +
                      (aditionalGifts>0?'(' + $word.repeat(aditionalGifts) + ')':'');
      //alert($blockString);
      return $blockString;
      }
      
      function organizeGifts() {
      let gifts = document.querySelector('input').value;
      //alert(gifts);
      let $numberAsString ='';
      let $word;
      let $finalString = '';
      for (let index = 0; index < gifts.length; index++) {
          
          //alert(gifts[index]);
          if(isItNumber(gifts[index])){
              $numberAsString += gifts[index];
          }else{
              $word = gifts[index];
              $finalString += organizeBlock($numberAsString, $word);
              $numberAsString = '';
          }
      }
      alert($finalString);
      }
   </script>
</html>